import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.*;

/**
 * Created by cteam016 on 10/22/16.
 */
public class Samples {

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static StringTokenizer tok;
    static int[] values;
    static int[] times;


    private static void findMin() {
    }

    private static void findMax() {
    }

    static void solve(String relation, String function, int interval) throws IOException {

        int time, sum, min, max, index;
        int cavg = 0, cmax = 0, cmin = 0;

        time = 0;
        index = 0;
        sum = 0;
        min = values[1];
        max = values[1];


        for (int i = 1; i < values.length; i++) {
            sum+=values[i-1];
            boolean minChanged=false,maxChanged=false;
            while (times[i] - times[index] > interval) {
                sum -= values[index];
                if (values[index] == min && function.equals("min")) {
                    minChanged=true;
                }
                if (values[index] == max && function.equals("max")) {
                    maxChanged=true;
                }
                index++;
            }
            if (minChanged || maxChanged){
                min=values[index];
                max=values[index];
                for (int j=index+1;j<i;j++){
                    if (min > values[j]) {
                        min=values[j];
                    }
                    if (max  < values[j]) {
                        max=values[j];
                    }
                }
            }

            int avg=sum/(i-index);

            int mult;
            mult = relation.equals("gt") ? 1 : -1;
            switch (function) {
                case "max":
                    cmax += (mult * max > mult * values[i]) ? 1 : 0;
                    System.out.println("max" + cmax);
                    break;
                case "min":
                    cmin += (mult * min > mult * values[i]) ? 1 : 0;
                    System.out.println("min" +cmin);
                    System.out.println("min=" +min);
                    break;
                case "avg":
                    cavg += (mult * avg > mult * values[i]) ? 1 : 0;
                    System.out.println("avg" +cavg);
                    break;
            }


        }

        switch (function) {
            case "max":
                System.out.println(cmax);
                break;
            case "min":
                System.out.println(cmin);
                break;
            case "avg":
                System.out.println(cavg);
                break;
        }

    }


    public static void main(String[] args) throws IOException {
        String st;
        boolean solved;
        while ((st = br.readLine()) != null) {
            int n = Integer.parseInt(st);
            values = new int[n];
            times = new int[n];
            for (int i = 0; i < n; i++) {
                tok = new StringTokenizer(br.readLine());
                times[i] = Integer.valueOf(tok.nextToken());
                values[i] = Integer.valueOf(tok.nextToken());
            }
            st = br.readLine();
            n = Integer.parseInt(st);
            for (int i = 0; i < n; i++) {
                tok = new StringTokenizer(br.readLine());
                solve(tok.nextToken(), tok.nextToken(), Integer.valueOf(tok.nextToken()));
            }

        }
    }

}
